Index: src/main/java/com/tourMate/dao/impl/HotelDaoImpl.java
===================================================================
--- src/main/java/com/tourMate/dao/impl/HotelDaoImpl.java	(revision 5528b99794e1d3a36baa8eb2f1829125b75f0174)
+++ src/main/java/com/tourMate/dao/impl/HotelDaoImpl.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
@@ -8,4 +8,5 @@
 import org.springframework.stereotype.Service;
 
+import java.util.Calendar;
 import java.util.Date;
 import java.util.List;
@@ -19,21 +20,15 @@
     @Override
     @Transactional
-    public void createHotel(Hotels hotel, long userId) {
-        User u = em.find(User.class, userId);
-        Hotels h = new Hotels(hotel.getHotelName(), hotel.getHotelDescripiton(), hotel.getHotelLocation(), hotel.getHotelEDBS(), hotel.getParking(), hotel.getPetFriendly(), hotel.getInternetAvailable(), u);
-        em.persist(h);
+    public void createHotel(Hotels hotel) {
+        em.persist(hotel);
     }
 
     @Override
     public List<Hotels> getHotels() {
-        List<Hotels> hoteli = em.createQuery("select h from Hotels h order by h.hotelId").getResultList();
-        System.out.println("OREEEEEEL");
-        return hoteli;
-        //return em.createQuery("select h from Hotels h order by h.hotelId").getResultList();
-    }
-
-    @Override
-    public List<Hotels> getHotelsForUser(long userId) {
-        User u = em.find(User.class, userId);
+        return em.createQuery("select h from Hotels h order by h.hotelId").getResultList();
+    }
+
+    @Override
+    public List<Hotels> getHotelsForUser(User u) {
         return em.createQuery("select h from Hotels h where h.owner = :u").setParameter("u", u).getResultList();
     }
@@ -46,13 +41,5 @@
     @Transactional
     @Override
-    public void editHotel(long hotelId, String hotelName, String hotelDescripiton, String hotelLocation, String hotelEDBS, Boolean parking, Boolean petFriendly, Boolean internetAvailable) {
-        Hotels hotel = findHotelByID(hotelId);
-        hotel.setHotelName(hotelName);
-        hotel.setHotelDescripiton(hotelDescripiton);
-        hotel.setHotelLocation(hotelLocation);
-        hotel.setHotelEDBS(hotelEDBS);
-        hotel.setParking(parking);
-        hotel.setPetFriendly(petFriendly);
-        hotel.setInternetAvailable(internetAvailable);
+    public void editHotel(Hotels hotel) {
         em.persist(hotel);
     }
@@ -60,7 +47,6 @@
     @Transactional
     @Override
-    public void deleteHotel(long hotelId) {
-        Hotels h = findHotelByID(hotelId);
-        em.remove(h);
+    public void deleteHotel(Hotels hotel) {
+        em.remove(hotel);
     }
 
@@ -89,4 +75,10 @@
     @Override
     @Transactional
+    public void  saveReservation(HotelRoomReservations hotelRoomReservations) {
+        em.persist(hotelRoomReservations);
+    }
+
+    @Override
+    @Transactional
     public HotelsImages findHotelImageById(long hotelImageId) {
         return em.find(HotelsImages.class, hotelImageId);
@@ -95,13 +87,11 @@
     @Override
     @Transactional
-    public void deleteHotelImage(long hotelImageId) {
-        HotelsImages hotelsImages = findHotelImageById(hotelImageId);
+    public void deleteHotelImage(HotelsImages hotelsImages) {
         em.remove(hotelsImages);
     }
 
     @Override
-    public List<HotelRoom> getRoomsOfHotel(long hotelId) {
-        Hotels h = findHotelByID(hotelId);
-        return em.createQuery("SELECT hr from HotelRoom hr where hr.hotel = :hotel").setParameter("hotel", h).getResultList();
+    public List<HotelRoom> getRoomsOfHotel(Hotels hotel) {
+        return em.createQuery("SELECT hr from HotelRoom hr where hr.hotel = :hotel").setParameter("hotel", hotel).getResultList();
     }
 
@@ -123,6 +113,5 @@
     @Transactional
     @Override
-    public void createRoom(Hotels hotel, String hotelRoomDescription, String hotelRoomName, Boolean kitchenAvailable, Boolean airConditioning, Boolean balcony, double price) {
-        HotelRoom hotelRoom = new HotelRoom(hotel, hotelRoomDescription, hotelRoomName, kitchenAvailable, airConditioning, balcony, price);
+    public void createRoom(HotelRoom hotelRoom) {
         em.persist(hotelRoom);
     }
@@ -130,13 +119,5 @@
     @Transactional
     @Override
-    public void editRoom(long hotelRoomId, Hotels hotel, String hotelRoomDescription, String hotelRoomName, Boolean kitchenAvailable, Boolean airConditioning, Boolean balcony, double price) {
-        HotelRoom hr = findRoomById(hotelRoomId);
-        hr.setHotel(hotel);
-        hr.setHotelRoomDescription(hotelRoomDescription);
-        hr.setHotelRoomName(hotelRoomName);
-        hr.setKitchenAvailable(kitchenAvailable);
-        hr.setAirConditioning(airConditioning);
-        hr.setBalcony(balcony);
-        hr.setPrice(price);
+    public void editRoom(HotelRoom hr) {
         em.persist(hr);
     }
@@ -144,6 +125,5 @@
     @Transactional
     @Override
-    public void deleteRoom(long hotelRoomId) {
-        HotelRoom hr = findRoomById(hotelRoomId);
+    public void deleteRoom(HotelRoom hr) {
         em.remove(hr);
     }
@@ -151,6 +131,5 @@
     @Transactional
     @Override
-    public void createRoomAvailible(HotelRoom hotelRoom, Date dateFrom, Date dateTo, int numberOfBeds) {
-        HotelRoomAvailable hra = new HotelRoomAvailable(hotelRoom, dateFrom, dateTo, numberOfBeds);
+    public void createRoomAvailible(HotelRoomAvailable hra) {
         em.persist(hra);
     }
@@ -158,10 +137,5 @@
     @Transactional
     @Override
-    public void editRoomAvailible(long hotelRoomAvailableId, HotelRoom hotelRoom, Date dateFrom, Date dateTo, int numberOfBeds) {
-        HotelRoomAvailable hr = findAvailibleRoomById(hotelRoomAvailableId);
-        hr.setHotelRoom(hotelRoom);
-        hr.setDateFrom(dateFrom);
-        hr.setDateTo(dateTo);
-        hr.setNumberOfBeds(numberOfBeds);
+    public void editRoomAvailible(HotelRoomAvailable hr) {
         em.persist(hr);
     }
@@ -169,6 +143,5 @@
     @Transactional
     @Override
-    public void deleteRoomAvailible(long hotelRoomAvailableId) {
-        HotelRoomAvailable hra = findAvailibleRoomById(hotelRoomAvailableId);
+    public void deleteRoomAvailible(HotelRoomAvailable hra) {
         em.remove(hra);
     }
@@ -190,22 +163,72 @@
 
     @Override
-    public List<HotelRoomAvailable> getRoomsAvailibilityByDateAndLocation(String hotelLocation, Date dateFrom, Date dateTo, int numberOfBeds) {
-        return em.createQuery("select hr from HotelRoomAvailable hr where hr.dateFrom <= :dateFrom and hr.dateTo >= :dateTo " +
-<<<<<<< HEAD
-                        "and hr.hotelRoom.hotel.hotelLocation LIKE :hotelLocation and hr.hotelRoom.numOfBeds >= :numBeds")
-=======
-                "and hr.hotelRoom.hotel.hotelLocation LIKE :hotelLocation and hr.numberOfBeds >= :numBeds")
->>>>>>> parent of ac19a0c (authContext impl, admin panel impl, search bar fixes, reservations listings impl)
-                .setParameter("hotelLocation", hotelLocation)
-                .setParameter("dateFrom", dateFrom)
-                .setParameter("dateTo", dateTo)
-                .setParameter("numBeds", numberOfBeds)
-                .getResultList();
-    }
-
-    @Override
-    @Transactional
-    public void createReservation(User user, HotelRoom hotelRoom, Date dateFrom, Date dateTo, Integer numberOfBeds) {
-        HotelRoomReservations r = new HotelRoomReservations(user, hotelRoom, dateFrom, dateTo, numberOfBeds);
+    public List<HotelRoomAvailable> getRoomsAvailibilityByDateAndLocation(String hotelLocation, Date dateFrom, Date dateTo, int numberOfBeds, Boolean flexible) {
+        if(flexible)
+        {
+            Calendar calendar = Calendar.getInstance();
+            Calendar calendar1 = Calendar.getInstance();
+            calendar.setTime(dateTo);
+            calendar1.setTime(dateFrom);
+            return em.createQuery("SELECT hr FROM HotelRoomAvailable hr WHERE " +
+                            "((hr.dateFrom <= :dateTo AND hr.dateTo >= :dateFrom) OR " +
+                            "(hr.dateFrom <= :dateToMinus1 AND hr.dateTo >= :dateFromMinus1) OR " +
+                            "(hr.dateFrom <= :dateToMinus2 AND hr.dateTo >= :dateFromMinus2) OR " +
+                            "(hr.dateFrom <= :dateToMinus3 AND hr.dateTo >= :dateFromMinus3) OR " +
+                            "(hr.dateFrom <= :dateToPlus1 AND hr.dateTo >= :dateFromPlus1) OR " +
+                            "(hr.dateFrom <= :dateToPlus2 AND hr.dateTo >= :dateFromPlus2) OR " +
+                            "(hr.dateFrom <= :dateToPlus3 AND hr.dateTo >= :dateFromPlus3)) " +
+                            "AND hr.hotelRoom.hotel.hotelLocation LIKE :hotelLocation " +
+                            "AND hr.hotelRoom.numOfBeds >= :numBeds")
+                    .setParameter("hotelLocation", hotelLocation)
+                    .setParameter("dateFrom", dateFrom)
+                    .setParameter("dateTo", dateTo)
+                    .setParameter("dateToMinus1", subtractDays(calendar, 1))
+                    .setParameter("dateToMinus2", subtractDays(calendar, 2))
+                    .setParameter("dateToMinus3", subtractDays(calendar, 3))
+                    .setParameter("dateToPlus1", addDays(calendar, 1))
+                    .setParameter("dateToPlus2", addDays(calendar, 2))
+                    .setParameter("dateToPlus3", addDays(calendar, 3))
+                    .setParameter("dateFromMinus1", subtractDays(calendar1, 1))
+                    .setParameter("dateFromMinus2", subtractDays(calendar1, 2))
+                    .setParameter("dateFromMinus3", subtractDays(calendar1, 3))
+                    .setParameter("dateFromPlus1", addDays(calendar1, 1))
+                    .setParameter("dateFromPlus2", addDays(calendar1, 2))
+                    .setParameter("dateFromPlus3", addDays(calendar1, 3))
+                    .setParameter("numBeds", numberOfBeds)
+                    .getResultList();
+        }
+        else
+        {
+            return em.createQuery("SELECT hr FROM HotelRoomAvailable hr WHERE " +
+                            "((hr.dateFrom <= :dateTo AND hr.dateTo >= :dateFrom)) " +
+                            "AND hr.hotelRoom.hotel.hotelLocation LIKE :hotelLocation " +
+                            "AND hr.hotelRoom.numOfBeds >= :numBeds")
+                    .setParameter("hotelLocation", hotelLocation)
+                    .setParameter("dateFrom", dateFrom)
+                    .setParameter("dateTo", dateTo)
+                    .setParameter("numBeds", numberOfBeds)
+                    .getResultList();
+        }
+
+
+
+
+    }
+
+    private Date addDays(Calendar calendar, int days) {
+        Calendar newCalendar = (Calendar) calendar.clone();
+        newCalendar.add(Calendar.DAY_OF_MONTH, days);
+        return newCalendar.getTime();
+    }
+
+    private Date subtractDays(Calendar calendar, int days) {
+        Calendar newCalendar = (Calendar) calendar.clone();
+        newCalendar.add(Calendar.DAY_OF_MONTH, -days);
+        return newCalendar.getTime();
+    }
+
+    @Override
+    @Transactional
+    public void createReservation(HotelRoomReservations  r) {
         em.persist(r);
     }
@@ -213,20 +236,13 @@
     @Override
     @Transactional
-    public void editReservation(long hotelRoomReservedId, User user, HotelRoom hotelRoom, Date dateFrom, Date dateTo, Integer numberOfBeds) {
-        HotelRoomReservations hr = findReservationById(hotelRoomReservedId);
-        hr.setUser(user);
-        hr.setHotelRoom(hotelRoom);
-        hr.setDateFrom(dateFrom);
-        hr.setDateTo(dateTo);
-        hr.setNumberOfBeds(numberOfBeds);
+    public void editReservation(HotelRoomReservations hr) {
         em.persist(hr);
-
-    }
-
-    @Transactional
-    @Override
-    public void deleteReservation(long hotelRoomReservedId) {
-        HotelRoomReservations r = findReservationById(hotelRoomReservedId);
-        em.remove(hotelRoomReservedId);
+    }
+
+    @Transactional
+    @Override
+    public void deleteReservation(HotelRoomReservations hr) {
+
+        em.remove(hr);
     }
 
@@ -244,6 +260,6 @@
     @Override
     public List<HotelRoomReservations> findReservationByHotel(Hotels hotel) {
-        List<HotelRoom> hotelRooms = getRoomsOfHotel(hotel.getHotelId());
-        return em.createQuery("select hr from HotelRoomReservations hr where hr.hotelRoom in :hotelRooms").setParameter("hotelRooms", hotelRooms).getResultList();
+        List<HotelRoom> hotelRooms = getRoomsOfHotel(hotel);
+        return em.createQuery("select hr from HotelRoomReservations hr where hr.hotelRoom.hotel = :hotel").setParameter("hotel", hotel).getResultList();
     }
 
Index: src/main/java/com/tourMate/dao/impl/MenuDaoImpl.java
===================================================================
--- src/main/java/com/tourMate/dao/impl/MenuDaoImpl.java	(revision 5528b99794e1d3a36baa8eb2f1829125b75f0174)
+++ src/main/java/com/tourMate/dao/impl/MenuDaoImpl.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
@@ -18,6 +18,5 @@
     @Transactional
     @Override
-    public void createMenu(String name, String ingredients, double price) {
-        Menu menu = new Menu(name, ingredients, price);
+    public void createMenu(Menu menu) {
         em.persist(menu);
     }
@@ -25,6 +24,5 @@
     @Transactional
     @Override
-    public void deleteMenu(long menuId) {
-        Menu menu = findMenuById(menuId);
+    public void deleteMenu(Menu menu) {
         em.remove(menu);
     }
@@ -42,9 +40,6 @@
     @Transactional
     @Override
-    public void editMenu(long menuId, String name, String ingredients, double price) {
-        Menu menu = findMenuById(menuId);
-        menu.setName(name);
-        menu.setIngredients(ingredients);
-        menu.setPrice(price);
+    public void editMenu(Menu menu) {
+
         em.persist(menu);
     }
Index: src/main/java/com/tourMate/dao/impl/RestaurantDaoImpl.java
===================================================================
--- src/main/java/com/tourMate/dao/impl/RestaurantDaoImpl.java	(revision 5528b99794e1d3a36baa8eb2f1829125b75f0174)
+++ src/main/java/com/tourMate/dao/impl/RestaurantDaoImpl.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
@@ -18,8 +18,6 @@
     @Override
     @Transactional
-    public void createRestaurant(Restaurant restaurant, long userId) {
-        User u = em.find(User.class, userId);
-        Restaurant r = new Restaurant(restaurant.getRestaurantName(), restaurant.getRestaurantLocation(), restaurant.getCousineType(), restaurant.getRestaurantDescription(), restaurant.getRestaurantEdbs(), u);
-        em.persist(r);
+    public void createRestaurant(Restaurant restaurant) {
+        em.persist(restaurant);
     }
 
@@ -43,7 +41,6 @@
     @Transactional
     @Override
-    public void removeRestaurantImage(long restaurantImageId){
-        RestaurantImages restaurantImage = findRestaurantImageById(restaurantImageId);
-        em.remove(restaurantImage);
+    public void removeRestaurantImage(RestaurantImages image){
+        em.remove(image);
     }
 
@@ -55,6 +52,5 @@
 
     @Override
-    public void deleteRestaurant(long restaurantID) {
-        Restaurant r = findRestaurantByID(restaurantID);
+    public void deleteRestaurant(Restaurant r) {
         em.remove(r);
     }
@@ -67,7 +63,5 @@
     @Override
     @Transactional
-    public void addMenuToRestaurant(long restaurantId, Menu menu) {
-        Restaurant r = findRestaurantByID(restaurantId);
-        menu.setRestaurant(r);
+    public void addMenuToRestaurant(Menu menu) {
         em.persist(menu);
     }
@@ -84,20 +78,6 @@
 
     @Override
-    @Transactional
-    public void editRestaurant(long restaurantID, String restaurantName, String restaurantLocation, String cousineType, String restaurantDescription, String restaurantEdbs, User restaurantOwner) {
-        Restaurant res = findRestaurantByID(restaurantID);
-        res.setRestaurantName(restaurantName);
-        res.setRestaurantLocation(restaurantLocation);
-        res.setRestaurantEdbs(restaurantEdbs);
-        res.setRestaurantDescription(restaurantDescription);
-        res.setRestaurantOwner(restaurantOwner);
-        res.setCousineType(cousineType);
-        em.persist(res);
-    }
-
-    @Override
     public List<RestaurantsTable> getRestaurantTables(long restaurantID) {
-        List<RestaurantsTable> restaurantsTables = getRestaurantTables(restaurantID);
-        return restaurantsTables;
+        return em.createQuery("select rt from RestaurantsTable rt where rt.restaurant.restaurantID = :restaurantId").setParameter("restaurantId", restaurantID).getResultList();
     }
 
@@ -109,36 +89,18 @@
     @Override
     @Transactional
-    public void createTable(Restaurant restaurant, int noSeats) {
-        RestaurantsTable resTable = new RestaurantsTable(restaurant, noSeats);
+    public void saveTable(RestaurantsTable resTable) {
         em.persist(resTable);
     }
 
-    @Override
-    @Transactional
-    public void editTable(Restaurant restaurant, long tableId, int noSeats) {
-        RestaurantsTable resTable = findTableById(tableId);
-        resTable.setRestaurant(restaurant);
-        resTable.setNoSeats(noSeats);
-        em.persist(resTable);
-    }
-
-    @Override
-    @Transactional
-    public void deleteTable(long tableId) {
-        RestaurantsTable rt  = findTableById(tableId);
+
+    @Override
+    @Transactional
+    public void deleteTable(RestaurantsTable rt) {
         em.persist(rt);
     }
 
     @Override
-    public List<Restaurant> getRestaurantsByUser(long userId) {
-        User u = em.find(User.class, userId);
+    public List<Restaurant> getRestaurantsByUser(User u) {
         return em.createQuery("select r from Restaurant r where r.restaurantOwner = :u").setParameter("u", u).getResultList();
-    }
-
-    @Override
-    @Transactional
-    public void createTableAvailable(RestaurantsTable restaurantsTable, Date hourFrom, Date hourTo, int noSeats) {
-        RestaurantsAvailible ra = new RestaurantsAvailible(restaurantsTable, hourFrom, hourTo, noSeats);
-        em.persist(ra);
     }
 
@@ -151,22 +113,11 @@
     @Override
     @Transactional
-    public void createTableAvailable(RestaurantsTable restaurantsTable, Date hourFrom, Date hourTo){
-        RestaurantsAvailible rta = new RestaurantsAvailible(restaurantsTable, hourFrom, hourTo);
-        em.persist(rta);
-    }
-
-    @Override
-    @Transactional
-    public void editTableAvailable(long tableId, Restaurant restaurant, int noSeats) {
-        RestaurantsTable rt = findTableById(tableId);
-        rt.setRestaurant(restaurant);
-        rt.setNoSeats(noSeats);
-        em.persist(rt);
-    }
-
-    @Override
-    @Transactional
-    public void deleteTableAvailable(long tableId) {
-        RestaurantsAvailible ra = findAvailableReservationByID(tableId);
+    public void saveTableAvailable(RestaurantsAvailible ra){
+        em.persist(ra);
+    }
+
+    @Override
+    @Transactional
+    public void deleteTableAvailable(RestaurantsAvailible ra) {
         em.remove(ra);
     }
@@ -183,20 +134,8 @@
     }
 
-    @Override
-    @Transactional
-    public void editReservation(long restaurantsTableId, RestaurantsTable rt, Date hourFrom, Date hourTo, int noSeats, User user) {
-        RestaurantReservations r = findReservationByID(restaurantsTableId);
-        r.setTable(rt);
-        r.setTimeFrom(hourFrom);
-        r.setTimeTo(hourTo);
-        r.setNoSeats(noSeats);
-        r.setUser(user);
-        em.persist(r);
-    }
-
-    @Override
-    @Transactional
-    public void deleteReservation(long restaurantsTableId) {
-        RestaurantReservations r = findReservationByID(restaurantsTableId);
+
+    @Override
+    @Transactional
+    public void deleteReservation(RestaurantReservations r) {
         em.remove(r);
     }
@@ -259,3 +198,32 @@
 
     }
+
+    @Override
+    public List<MenuImages> getMenuImages(long menuId) {
+        return em.createQuery("select ri from MenuImages ri where ri.menu.id = :menuId").setParameter("menuId", menuId).getResultList();
+    }
+
+    @Override
+    public List<MenuImages> getMenuImagesByRestaurant(Restaurant resta) {
+        return em.createQuery("select mi from MenuImages mi where mi.menu.restaurant = :restaurant")
+                .setParameter("restaurant", resta)
+                .getResultList();
+    }
+
+    @Transactional
+    @Override
+    public void addMenuImage(MenuImages menuImages) {
+        em.persist(menuImages);
+    }
+
+    @Override
+    public Menu findMenuId(Long menuId) {
+        return em.find(Menu.class, menuId);
+    }
+
+    @Override
+    @Transactional
+    public void saveReservation(RestaurantReservations restaurantReservations) {
+        em.persist(restaurantReservations);
+    }
 }
Index: src/main/java/com/tourMate/dao/impl/ReviewDaoImpl.java
===================================================================
--- src/main/java/com/tourMate/dao/impl/ReviewDaoImpl.java	(revision 5528b99794e1d3a36baa8eb2f1829125b75f0174)
+++ src/main/java/com/tourMate/dao/impl/ReviewDaoImpl.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
@@ -25,6 +25,5 @@
 
     @Override
-    public void deleteReview(long id) {
-        Reviews review = findReviewById(id);
+    public void deleteReview(Reviews review) {
         em.remove(review);
     }
@@ -36,12 +35,5 @@
 
     @Override
-    public void editReview(long id, String title, String description, int numStar, Hotels hotel, Restaurant restaurant, Transport transport) {
-        Reviews review = findReviewById(id);
-        review.setDescription(description);
-        review.setHotel(hotel);
-        review.setRestaurant(restaurant);
-        review.setTitle(title);
-        review.setNumStar(numStar);
-        review.setTransport(transport);
+    public void editReview(Reviews review) {
         em.persist(review);
     }
Index: src/main/java/com/tourMate/dao/impl/TransportDaoImpl.java
===================================================================
--- src/main/java/com/tourMate/dao/impl/TransportDaoImpl.java	(revision 5528b99794e1d3a36baa8eb2f1829125b75f0174)
+++ src/main/java/com/tourMate/dao/impl/TransportDaoImpl.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
@@ -10,5 +10,4 @@
 import org.springframework.stereotype.Service;
 
-import java.util.Collection;
 import java.util.Date;
 import java.util.List;
@@ -22,7 +21,5 @@
     @Override
     @Transactional
-    public void createTransport(String transportName, String carBrand, String carType, int carManufacturedYear, int noPassengers, int noBags, long EMBG, User owner, String carPlate) {
-        User u = em.find(User.class, 1);
-        Transport t=new Transport(transportName,carBrand,carType,carManufacturedYear,noPassengers,noBags,EMBG,u,carPlate);
+    public void createTransport(Transport t) {
         em.persist(t);
     }
@@ -30,6 +27,5 @@
     @Override
     @Transactional
-    public void deleteTransport(long transportId) {
-        Transport t=getTransportById(transportId);
+    public void deleteTransport(Transport t) {
         em.remove(t);
     }
@@ -41,6 +37,5 @@
 
     @Override
-    public List<TransportDto> getTransportsByUser(long userId) {
-        User u = em.find(User.class, userId);
+    public List<TransportDto> getTransportsByUser(User u) {
         List<Transport> transports = em.createQuery("select t from Transport t where t.owner = :u").setParameter("u", u).getResultList();
         return transports.stream().map(x -> new TransportDto(
@@ -62,12 +57,18 @@
                         y.getFreeSpace(),
                         y.getTime(),
-                        y.getRoutes()
-                )).toList()
+                        y.getRoutes(),
+                        y.getRoutes().stream()
+                                .mapToDouble(TransportRoute::getPrice)
+                                .max().orElse(0)
+                )).toList(),
+                x.getAvailableRoutes().stream()
+                        .flatMapToDouble(y -> y.getRoutes()
+                                .stream()
+                                .mapToDouble(TransportRoute::getPrice)).max().orElseGet(() -> 0)
         )).toList();
     }
 
     @Override
-    public List<RouteListingDto> getRoutesForTransport(long transportId) {
-        Transport t = em.find(Transport.class, transportId);
+    public List<RouteListingDto> getRoutesForTransport(Transport t) {
         List<TransportAvailible> transportsAvailible = em.createQuery("select ta from TransportAvailible ta where ta.transport = :transport").setParameter("transport", t).getResultList();
         return transportsAvailible.stream().map(x -> new RouteListingDto(
@@ -78,5 +79,8 @@
                 x.getFreeSpace(),
                 x.getTime(),
-                x.getRoutes()
+                x.getRoutes(),
+                x.getRoutes().stream()
+                        .mapToDouble(TransportRoute::getPrice)
+                        .max().orElse(0)
         )).toList();
     }
@@ -103,8 +107,16 @@
                         y.getFreeSpace(),
                         y.getTime(),
-                        y.getRoutes()
-                )).toList());
-    }
-
+                        y.getRoutes(),
+                        y.getRoutes().stream()
+                                .mapToDouble(TransportRoute::getPrice)
+                                .max().orElse(0)
+                )).toList(),
+                x.getAvailableRoutes().stream()
+                        .flatMapToDouble(y -> y.getRoutes()
+                                                        .stream()
+                                                        .mapToDouble(TransportRoute::getPrice)).max().orElseGet(() -> 0));
+    }
+
+    @Override
     public Transport getTransportById(long transportId)
     {
@@ -114,15 +126,5 @@
     @Override
     @Transactional
-    public void editTransport(long transportID, String transportName, String carBrand, String carType, int carManufacturedYear, int noPassengers, int noBags, long EMBG, User owner, String carPlate) {
-        Transport t=getTransportById(transportID);
-        t.setTransportName(transportName);
-        t.setCarBrand(carBrand);
-        t.setCarType(carType);
-        t.setCarManufacturedYear(carManufacturedYear);
-        t.setNoPassengers(noPassengers);
-        t.setNoBags(noBags);
-        t.setEMBG(EMBG);
-        t.setOwner(owner);
-        t.setCarPlate(carPlate);
+    public void editTransport(Transport t) {
         em.persist(t);
     }
@@ -150,8 +152,11 @@
 
     @Override
-    public List<TransportRoute> getTransportsAvailableByFilters(String fromL, String toL, Date date) {
+    public List<TransportRoute> getTransportsAvailableByFilters(String fromL, String toL, Date date, int numPassengers) {
         System.out.println(fromL + " " + toL);
-        return em.createQuery("select h from TransportRoute h where h.from = :froml and h.to = :tol").setParameter("froml", fromL).
-                setParameter("tol", toL).getResultList();
+        return em.createQuery("select h from TransportRoute h where h.from = :froml and h.to = :tol and h.freeSpace >= :nump")
+                .setParameter("froml", fromL)
+                .setParameter("tol", toL)
+                .setParameter("nump", numPassengers)
+                .getResultList();
     }
 
@@ -168,37 +173,11 @@
     @Override
     @Transactional
-    public void createTransportAvailable(Transport transport, String departureLocation, String arrivalLocation, Date date, Integer noSeats, Date departureHour, Collection<TransportRoute> routes) {
-        TransportAvailible ta=new TransportAvailible(transport,departureLocation,arrivalLocation,date,noSeats,departureHour);
+    public void createTransportAvailable(TransportAvailible ta) {
         em.persist(ta);
-        List<TransportRoute> routes1 = routes.stream().toList();
-        routes.forEach(x -> {
-            createTransportRoute(ta, x.getFrom(), x.getTo(), x.getPrice(), x.getDeparture(), x.getArrival(), x.getFreeSpace(), x.getOrder());
-        });
-    }
-
-    @Override
-    @Transactional
-    public void editTransportReservation(Transport transport, long reservationID, String departureLocation, String arrivalLocation, Date date, Integer noSeats, User user, Date departureHour)
-    {
-//        TransportReservation tr=findTransportReservationByID(reservationID);
-//        tr.setTransport(transport);
-//        tr.setDepartureLocation(departureLocation);
-//        tr.setArrivalLocation(arrivalLocation);
-//        tr.setDate(date);
-//        tr.setNoSeats(noSeats);
-//        tr.setUser(user);
-//        tr.setDepartureHour(departureHour);
-//        em.persist(tr);
-    }
-
-    @Override
-    public void editTransportAvailable(Transport transport, long availableID, String departureLocation, String arrivalLocation, Date date, Integer noSeats, Date departureHour) {
-        TransportAvailible ta=findTransportAvailableByID(availableID);
-        ta.setTransport(transport);
-        ta.setFrom(departureLocation);
-        ta.setTo(arrivalLocation);
-        ta.setDate(date);
-        ta.setFreeSpace(noSeats);
-        ta.setTime(departureHour);
+
+    }
+
+    @Override
+    public void editTransportAvailable(TransportAvailible ta) {
         em.persist(ta);
     }
@@ -224,4 +203,10 @@
     }
 
+    @Transactional
+    @Override
+    public void saveReservation(TransportReservation transportReservation) {
+        em.persist(transportReservation);
+    }
+
     @Override
     public List<TransportReservation> findReservationByUser(User user) {
@@ -235,6 +220,5 @@
     @Override
     @Transactional
-    public void deleteTransportReservation(long reservationID) {
-        TransportReservation tr=findTransportReservationByID(reservationID);
+    public void deleteTransportReservation(TransportReservation tr) {
         em.remove(tr);
     }
@@ -242,36 +226,32 @@
     @Override
     @Transactional
-    public void deleteTransportAvailable(long availableID) {
-        TransportAvailible ta=findTransportAvailableByID(availableID);
+    public void deleteTransportAvailable(TransportAvailible ta) {
         em.remove(ta);
     }
 
     @Override
-    public void createTransportRoute(TransportAvailible parentRoute, String from, String to, double price, Date departure, Date arrival, int freeSpace, int order) {
-        TransportRoute tr = new TransportRoute(parentRoute, from, to, price, departure, arrival, freeSpace, order);
+    @Transactional
+    public void createTransportRoute(TransportRoute tr) {
         em.persist(tr);
     }
 
     @Override
-    public void deleteTransportRoute(long transportRouteId) {
-        TransportRoute tr = findTransportRouteById(transportRouteId);
+    public void deleteTransportRoute(TransportRoute tr) {
         em.remove(tr);
     }
 
     @Override
-    public void editTransportRoute(long transportRouteId, TransportAvailible parentRoute, String from, String to, double price, Date departure, Date arrival, int freeSpace, int order) {
-        TransportRoute tr = findTransportRouteById(transportRouteId);
-        tr.setParentRoute(parentRoute);
-        tr.setFrom(from);
-        tr.setTo(to);
-        tr.setPrice(price);
-        tr.setDeparture(departure);
-        tr.setArrival(arrival);
-        tr.setFreeSpace(freeSpace);
-        tr.setOrder(order);
+    public void editTransportRoute(TransportRoute tr) {
         em.persist(tr);
 
     }
 
+    @Override
+    public List<TransportReservation> findTransportReservationByTransportId(Transport t) {
+        return em.createQuery("SELECT tr from TransportReservation tr where tr.transportRoute.parentRoute.transport= :transport")
+                .setParameter("transport", t)
+                .getResultList();
+    }
+
 
 }
